package org.thdl.roster.om;


import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.ObjectUtils;
import org.apache.torque.TorqueException;
import org.apache.torque.om.BaseObject;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.util.Criteria;
import org.apache.torque.util.Transaction;


/**
 * This class was autogenerated by Torque on:
 *
 * [Wed May 14 19:01:42 EDT 2003]
 *
 * You should not use this class directly.  It should not even be
 * extended all references should be to Phone
 */
public abstract class BasePhone extends BaseObject
{
    /** The Peer class */
    private static final PhonePeer peer =
        new PhonePeer();

                  
        /**
         * The value for the id field
         */
        private Integer id;
              
        /**
         * The value for the country_code field
         */
        private Integer country_code;
              
        /**
         * The value for the area_code field
         */
        private Integer area_code;
              
        /**
         * The value for the number field
         */
        private Integer number;
      
      
        /**
         * Get the Id
         *
         * @return Integer
         */
        public Integer getId()
        {
            return id;
        }

                                                                              
        /**
         * Set the value of Id
         *
         * @param v new value
         */
        public void setId(Integer v) throws TorqueException
        {
          


         if (!ObjectUtils.equals(this.id, v))
        {
             this.id = v;
            setModified(true);
        }

                  
                                                  
              // update associated ContactInfo
              if (collContactInfosRelatedByPhone != null)
              {
                  for (int i = 0; i < collContactInfosRelatedByPhone.size(); i++)
                  {
                      ((ContactInfo) collContactInfosRelatedByPhone.get(i))
                          .setPhone(v);
                  }
              }
                                                              
              // update associated ContactInfo
              if (collContactInfosRelatedByFax != null)
              {
                  for (int i = 0; i < collContactInfosRelatedByFax.size(); i++)
                  {
                      ((ContactInfo) collContactInfosRelatedByFax.get(i))
                          .setFax(v);
                  }
              }
                                   }


        /**
         * Get the CountryCode
         *
         * @return Integer
         */
        public Integer getCountryCode()
        {
            return country_code;
        }

                                            
        /**
         * Set the value of CountryCode
         *
         * @param v new value
         */
        public void setCountryCode(Integer v) 
        {
          


         if (!ObjectUtils.equals(this.country_code, v))
        {
             this.country_code = v;
            setModified(true);
        }

                  
                       }


        /**
         * Get the AreaCode
         *
         * @return Integer
         */
        public Integer getAreaCode()
        {
            return area_code;
        }

                                            
        /**
         * Set the value of AreaCode
         *
         * @param v new value
         */
        public void setAreaCode(Integer v) 
        {
          


         if (!ObjectUtils.equals(this.area_code, v))
        {
             this.area_code = v;
            setModified(true);
        }

                  
                       }


        /**
         * Get the Number
         *
         * @return Integer
         */
        public Integer getNumber()
        {
            return number;
        }

                                            
        /**
         * Set the value of Number
         *
         * @param v new value
         */
        public void setNumber(Integer v) 
        {
          


         if (!ObjectUtils.equals(this.number, v))
        {
             this.number = v;
            setModified(true);
        }

                  
                       }


 
        
                    
      
    /**
     * Collection to store aggregation of collContactInfosRelatedByPhone
     */
    protected List collContactInfosRelatedByPhone;

    /**
     * Temporary storage of collContactInfosRelatedByPhone to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     */
    protected void initContactInfosRelatedByPhone()
    {
        if (collContactInfosRelatedByPhone == null)
        {
            collContactInfosRelatedByPhone = new ArrayList();
        }
    }

    /**
     * Method called to associate a ContactInfo object to this object
     * through the ContactInfo foreign key attribute
     *
     * @param l ContactInfo
     * @throws TorqueException
     */
    public void addContactInfoRelatedByPhone(ContactInfo l) throws TorqueException
    {
        getContactInfosRelatedByPhone().add(l);
        l.setPhoneRelatedByPhone((Phone) this);
    }

    /**
     * The criteria used to select the current contents of collContactInfosRelatedByPhone
     */
    private Criteria lastContactInfosRelatedByPhoneCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getContactInfosRelatedByPhone(new Criteria())
     *
     * @throws TorqueException
     */
    public List getContactInfosRelatedByPhone() throws TorqueException
    {
        if (collContactInfosRelatedByPhone == null)
        {
            collContactInfosRelatedByPhone = getContactInfosRelatedByPhone(new Criteria(10));
        }
        return collContactInfosRelatedByPhone;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Phone has previously
     * been saved, it will retrieve related ContactInfosRelatedByPhone from storage.
     * If this Phone is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List getContactInfosRelatedByPhone(Criteria criteria) throws TorqueException
    {
        if (collContactInfosRelatedByPhone == null)
        {
            if (isNew())
            {
               collContactInfosRelatedByPhone = new ArrayList();
            }
            else
            {
                   criteria.add(ContactInfoPeer.PHONE, getId() );
                   collContactInfosRelatedByPhone = ContactInfoPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                   criteria.add(ContactInfoPeer.PHONE, getId());
                   if (!lastContactInfosRelatedByPhoneCriteria.equals(criteria))
                {
                    collContactInfosRelatedByPhone = ContactInfoPeer.doSelect(criteria);
                }
            }
        }
        lastContactInfosRelatedByPhoneCriteria = criteria;

        return collContactInfosRelatedByPhone;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getContactInfosRelatedByPhone(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getContactInfosRelatedByPhone(Connection con) throws TorqueException
    {
        if (collContactInfosRelatedByPhone == null)
        {
            collContactInfosRelatedByPhone = getContactInfosRelatedByPhone(new Criteria(10), con);
        }
        return collContactInfosRelatedByPhone;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Phone has previously
     * been saved, it will retrieve related ContactInfosRelatedByPhone from storage.
     * If this Phone is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getContactInfosRelatedByPhone(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collContactInfosRelatedByPhone == null)
        {
            if (isNew())
            {
               collContactInfosRelatedByPhone = new ArrayList();
            }
            else
            {
                     criteria.add(ContactInfoPeer.PHONE, getId());
                     collContactInfosRelatedByPhone = ContactInfoPeer.doSelect(criteria, con);
             }
         }
         else
         {
             // criteria has no effect for a new object
             if (!isNew())
             {
                 // the following code is to determine if a new query is
                 // called for.  If the criteria is the same as the last
                 // one, just return the collection.
                     criteria.add(ContactInfoPeer.PHONE, getId());
                     if (!lastContactInfosRelatedByPhoneCriteria.equals(criteria))
                 {
                     collContactInfosRelatedByPhone = ContactInfoPeer.doSelect(criteria, con);
                 }
             }
         }
         lastContactInfosRelatedByPhoneCriteria = criteria;

         return collContactInfosRelatedByPhone;
     }

     

     
      
      
          
                    
                
        
                
    
      
         
              
                            
                
        
                        
    
      
         
              
                            
                
        
                
      



                 
      
    /**
     * Collection to store aggregation of collContactInfosRelatedByFax
     */
    protected List collContactInfosRelatedByFax;

    /**
     * Temporary storage of collContactInfosRelatedByFax to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     */
    protected void initContactInfosRelatedByFax()
    {
        if (collContactInfosRelatedByFax == null)
        {
            collContactInfosRelatedByFax = new ArrayList();
        }
    }

    /**
     * Method called to associate a ContactInfo object to this object
     * through the ContactInfo foreign key attribute
     *
     * @param l ContactInfo
     * @throws TorqueException
     */
    public void addContactInfoRelatedByFax(ContactInfo l) throws TorqueException
    {
        getContactInfosRelatedByFax().add(l);
        l.setPhoneRelatedByFax((Phone) this);
    }

    /**
     * The criteria used to select the current contents of collContactInfosRelatedByFax
     */
    private Criteria lastContactInfosRelatedByFaxCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getContactInfosRelatedByFax(new Criteria())
     *
     * @throws TorqueException
     */
    public List getContactInfosRelatedByFax() throws TorqueException
    {
        if (collContactInfosRelatedByFax == null)
        {
            collContactInfosRelatedByFax = getContactInfosRelatedByFax(new Criteria(10));
        }
        return collContactInfosRelatedByFax;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Phone has previously
     * been saved, it will retrieve related ContactInfosRelatedByFax from storage.
     * If this Phone is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List getContactInfosRelatedByFax(Criteria criteria) throws TorqueException
    {
        if (collContactInfosRelatedByFax == null)
        {
            if (isNew())
            {
               collContactInfosRelatedByFax = new ArrayList();
            }
            else
            {
                   criteria.add(ContactInfoPeer.FAX, getId() );
                   collContactInfosRelatedByFax = ContactInfoPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                   criteria.add(ContactInfoPeer.FAX, getId());
                   if (!lastContactInfosRelatedByFaxCriteria.equals(criteria))
                {
                    collContactInfosRelatedByFax = ContactInfoPeer.doSelect(criteria);
                }
            }
        }
        lastContactInfosRelatedByFaxCriteria = criteria;

        return collContactInfosRelatedByFax;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getContactInfosRelatedByFax(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getContactInfosRelatedByFax(Connection con) throws TorqueException
    {
        if (collContactInfosRelatedByFax == null)
        {
            collContactInfosRelatedByFax = getContactInfosRelatedByFax(new Criteria(10), con);
        }
        return collContactInfosRelatedByFax;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Phone has previously
     * been saved, it will retrieve related ContactInfosRelatedByFax from storage.
     * If this Phone is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getContactInfosRelatedByFax(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collContactInfosRelatedByFax == null)
        {
            if (isNew())
            {
               collContactInfosRelatedByFax = new ArrayList();
            }
            else
            {
                     criteria.add(ContactInfoPeer.FAX, getId());
                     collContactInfosRelatedByFax = ContactInfoPeer.doSelect(criteria, con);
             }
         }
         else
         {
             // criteria has no effect for a new object
             if (!isNew())
             {
                 // the following code is to determine if a new query is
                 // called for.  If the criteria is the same as the last
                 // one, just return the collection.
                     criteria.add(ContactInfoPeer.FAX, getId());
                     if (!lastContactInfosRelatedByFaxCriteria.equals(criteria))
                 {
                     collContactInfosRelatedByFax = ContactInfoPeer.doSelect(criteria, con);
                 }
             }
         }
         lastContactInfosRelatedByFaxCriteria = criteria;

         return collContactInfosRelatedByFax;
     }

     

     
      
      
          
                    
                
        
                
    
      
         
              
                            
                
        
                
    
      
         
              
                            
                
        
                        
      



     
    
    private static List fieldNames = null;

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static synchronized List getFieldNames()
    {
      if (fieldNames == null)
      {
        fieldNames = new ArrayList();
            fieldNames.add("Id");
            fieldNames.add("CountryCode");
            fieldNames.add("AreaCode");
            fieldNames.add("Number");
            fieldNames = Collections.unmodifiableList(fieldNames);
      }
      return fieldNames;
    }

    /**
     * Retrieves a field from the object by name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
            if (name.equals("Id"))
    {
              return getId();
          }
            if (name.equals("CountryCode"))
    {
              return getCountryCode();
          }
            if (name.equals("AreaCode"))
    {
              return getAreaCode();
          }
            if (name.equals("Number"))
    {
              return getNumber();
          }
            return null;
    }
    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
            if (name.equals(PhonePeer.ID))
        {
              return getId();
          }
            if (name.equals(PhonePeer.COUNTRY_CODE))
        {
              return getCountryCode();
          }
            if (name.equals(PhonePeer.AREA_CODE))
        {
              return getAreaCode();
          }
            if (name.equals(PhonePeer.NUMBER))
        {
              return getNumber();
          }
            return null;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
            if (pos == 0)
    {
              return getId();
          }
            if (pos == 1)
    {
              return getCountryCode();
          }
            if (pos == 2)
    {
              return getAreaCode();
          }
            if (pos == 3)
    {
              return getNumber();
          }
                return null;
    }

     


    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @throws Exception
     */
    public void save() throws Exception
    {
             save(PhonePeer.getMapBuilder()
                .getDatabaseMap().getName());
     }

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     * Note: this code is here because the method body is
     * auto-generated conditionally and therefore needs to be
     * in this file instead of in the super class, BaseObject.
     *
     * @param dbName
     * @throws TorqueException
     */
    public void save(String dbName) throws TorqueException
    {
        Connection con = null;
         try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }

     }

      /** flag to prevent endless save loop, if this object is referenced
        by another object which falls in this transaction. */
    private boolean alreadyInSave = false;
      /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally
     *
     * @param con
     * @throws TorqueException
     */
    public void save(Connection con) throws TorqueException
    {
        if (!alreadyInSave)
      {
        alreadyInSave = true;



  
        // If this object has been modified, then save it to the database.
        if (isModified())
        {
            if (isNew())
            {
                PhonePeer.doInsert((Phone) this, con);
                setNew(false);
            }
            else
            {
                PhonePeer.doUpdate((Phone) this, con);
            }
        }

                                                
                
          if (collContactInfosRelatedByPhone != null)
          {
              for (int i = 0; i < collContactInfosRelatedByPhone.size(); i++)
              {
                  ((ContactInfo) collContactInfosRelatedByPhone.get(i)).save(con);
              }
          }
                                                    
                
          if (collContactInfosRelatedByFax != null)
          {
              for (int i = 0; i < collContactInfosRelatedByFax.size(); i++)
              {
                  ((ContactInfo) collContactInfosRelatedByFax.get(i)).save(con);
              }
          }
                  alreadyInSave = false;
      }
      }


                        
    
    

        /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param  id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        throws TorqueException
    {
                    setId(new Integer(((NumberKey) key).intValue()));
            }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
                    setId(new Integer(key));
            }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }

 

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public Phone copy() throws TorqueException
    {
        return copyInto(new Phone());
    }

    protected Phone copyInto(Phone copyObj) throws TorqueException
    {
        copyObj.setId(id);
        copyObj.setCountryCode(country_code);
        copyObj.setAreaCode(area_code);
        copyObj.setNumber(number);

  copyObj.setNew(false);
                                                
                
        List v = getContactInfosRelatedByPhone();
        for (int i = 0; i < v.size(); i++)
        {
            ContactInfo obj = (ContactInfo) v.get(i);
            copyObj.addContactInfoRelatedByPhone(obj.copy());
            ((Persistent) v.get(i)).setNew(true);
        }
                                                          
                
        v = getContactInfosRelatedByFax();
        for (int i = 0; i < v.size(); i++)
        {
            ContactInfo obj = (ContactInfo) v.get(i);
            copyObj.addContactInfoRelatedByFax(obj.copy());
            ((Persistent) v.get(i)).setNew(true);
        }
                copyObj.setNew(true);

                      copyObj.setId((Integer)null);
                                return copyObj;
    }

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public PhonePeer getPeer()
    {
        return peer;
    }
}
